<p align="center">
  <img height="200px" width="200px" style="text-align: center;" src="https://raw.githubusercontent.com/MurhafSousli/ngx-highlightjs/dev/demo/src/assets/logo.svg">
  <h1 align="center">Angular Highlight.js</h1>
</p>

Super easy to use, auto highlight code and auto-detect language 

___
[![npm](https://img.shields.io/badge/demo-online-ed1c46.svg)](https://murhafsousli.github.io/ngx-highlightjs/)
[![npm](https://img.shields.io/npm/v/ngx-highlightjs.svg?maxAge=2592000?style=plastic)](https://www.npmjs.com/package/ngx-highlightjs) 
[![Build Status](https://travis-ci.org/MurhafSousli/ngx-highlightjs.svg?branch=master)](https://www.npmjs.com/package/ngx-highlightjs) 
[![npm](https://img.shields.io/npm/l/express.svg?maxAge=2592000)](/LICENSE)


## Installation

1. To install this library, run:

```bash
$ npm install --save ngx-highlightjs
```

2. Head to [highlight.js download page](https://highlightjs.org/download/) and get your custom package bundle including only the languages you need.

3. Create new folder in `src/assets/highlight.js` and extract the downloaded zip file.

4. import highlight.js script in `index.html`

```html
<script src="assets/highlight.js/highlight.pack.js"></script>
```

5. import highlight.js theme in global style `style.scss`

```scss
@import 'assets/highlight.js/styles/monokai-sublime.css';
```


_[List of all available themes from highlight.js](https://github.com/isagalaev/highlight.js/tree/master/src/styles)_


### SystemJS

If you are using SystemJS, you should also adjust your configuration to point to the UMD bundle.

In your systemjs config file, map needs to tell the System loader where to look for `ngx-highlightjs`:
```js
map: {
  'ngx-highlightjs': 'node_modules/ngx-highlightjs/bundles/ngx-highlightjs.umd.js',
}
```
Here is a working [plunker](https://plnkr.co/edit/OULKGeN9jG1KHREYZ4YF?p=preview).

## Usage

Import `HighlightModule` library from any module:

```ts
import { HighlightModule } from 'ngx-highlightjs';

@NgModule({
  imports: [
    // ...
    HighlightModule
  ]
})
export class AppModule { }
```


 - Highlight a code element

```html
<!-- Highlight target element -->
<pre><code highlight [textContent]="someCode"></code></pre>
<div [textContent]="anotherCode"></div>
```
 - Highlight all code elements

```html
<!-- Highlight child elements of type <pre><code> -->
<div highlight="all">
  <pre><code [textContent]="htmlCode"></code></pre>
  <pre><code [textContent]="tsCode"></code></pre>
  <pre><code [textContent]="cssCode"></code></pre>
</div>
```
 - Highlight custom elements

```html
<!-- Highlight custom child elements -->
<div highlight="section code">
  <section><code [textContent]="pythonCode"></code></section>
  <section><code [textContent]="swiftCode"></code></section>
</div>
```

## Options

 - Highlight element(s)

  **[highlight]**: string, default `''`

   if you just use `highlight` on the element, it will highlight it
   if you use `highlight="all"`: highlights all child code elements.
   if you use `highlight="p code"`: highlights custom child elements.

 - Auto-highlight on changes

  **[hlAuto]**: boolean, default `true`;

 - Highlight delay 

  **[hlDelay]**: number, default `200` ms;

## Development

To generate all `*.js`, `*.d.ts` and `*.metadata.json` files:

```bash
$ npm run build
```

To lint all `*.ts` files:

```bash
$ npm run lint
```

## Issues

If you identify any errors in the library, or have an idea for an improvement, please open an [issue](https://github.com/MurhafSousli/ngx-highlightjs/issues). I am excited to see what the community thinks of this project, and I would love your input!

## Author

 **[Murhaf Sousli](http://murhafsousli.com)**

 - [github/murhafsousli](https://github.com/MurhafSousli)
 - [twitter/murhafsousli](https://twitter.com/MurhafSousli)

